#include <pic.h>
#include <stdio.h>
#include<htc.h>
#include "clk_freq.h"
#include "always.h"
#include "delay.h"

#define _XTAL_FREQ 16000000		

#define Drive1	RC0 


float LDR1;
float diff=2.0;
float Gain=1.0;
bit value_saved_flag=0;
unsigned char EEPROM_ADDRESS=0x00;

float Readadc( unsigned char ch);
void Value_compare_1(void);
void Wait(unsigned int delay);
void initADC(void);

void ewrite(unsigned char data, unsigned char address); //TO write failure on eeprom
unsigned char eread(unsigned char address);                //TO read failures from EEPROM
void eerase(unsigned char address);               //to Erase eeprom

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
void main()
{
	TRISA=0xFF;
	TRISC=0x10;
	
	Drive1=0; 
	LDR1=0.0;
	
	while(1)
	{
		LDR1=Readadc(1);
		
		if (!RC4)
		{
			RC5=1;	//indication that values has been stored eeprom
			value_saved_flag=1;
		}
		else
			RC5=0;
		if ((value_saved_flag ==1) && (RC4==1))
		{
			Value_compare_1();
			asm("CLRWDT");
		}
	}
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

float Readadc(unsigned char ch)
{
 	int ADC_DIG;
	float ADC_DEC;
	if(ch==1)
	{
		ADCON0=0b10000001;
	}
 	else
	{
		 ADCON0=ADCON0;
	} 
	__delay_us(20);
	GODONE = 1;
	
	while(GODONE);
	ADC_DIG=(ADRESH<<8) + ADRESL;
	ADC_DEC = (ADC_DIG*5.0* Gain)/1024;
	if (!RC4)
	{
		
		ewrite(ADRESH,  EEPROM_ADDRESS);
		EEPROM_ADDRESS+=1;
		ewrite(ADRESL,  EEPROM_ADDRESS);
		EEPROM_ADDRESS+=1;
	}	

	return ADC_DEC;
	asm("CLRWDT");
}

///////////////////////////////////////////////////////////////////

void Value_compare_1(void)
{


  		
  		if(LDR1 > diff)
  		{
   			Drive1 = 1;
   		
  		}
  		
	}
		
	else
  		{ 
			Drive1 = 0; 
		}  		
 asm("CLRWDT");
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
void Wait(unsigned int delay)
{
	for(;delay;delay--);
	__delay_ms(100);
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
void initADC(void)
{

	ADCON0=0b10000101;
	ADIF=0;
	ADIE=0;
	PEIE=0;
	GIE=0;
asm("CLRWDT");

}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
unsigned char eread(unsigned char address)   //Read From EEPROM and if failures display on lcd
{ 
	unsigned char r = 0x00;
  	EEADR = address;
  	RD = 1;
 	wait(2000);
  	r = EEDATA;
	return r;
  
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
void ewrite(unsigned char data, unsigned char address)
{
	EEADR = address;
 	EEDATA = data;
 	WREN = 1;
 	EECON2 = 0x55; // protection sequence
 	EECON2 = 0xaa;
 	WR = 1;  // begin programming sequnce
 	//wait(2000);
 
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/*void eerase(unsigned char address)
{ 
	
     	
     	EEADR = address;
     	ewrite(0x00);
  
}*/